import { Vector3, IUniform } from 'three';
import { Matrix4 } from 'three';
import { ExtendedMeshNormalMaterial, Uniforms } from './SpeckleMaterial';
declare class SpeckleNormalMaterial extends ExtendedMeshNormalMaterial {
    protected static readonly matBuff: Matrix4;
    protected static readonly vecBuff0: Vector3;
    protected static readonly vecBuff1: Vector3;
    protected static readonly vecBuff2: Vector3;
    protected get vertexShader(): string;
    protected get fragmentShader(): string;
    protected get baseUniforms(): {
        [uniform: string]: IUniform;
    };
    protected get uniformsDef(): Uniforms;
    constructor(parameters: any, defines?: any[]);
    /** We need a unique key per program */
    customProgramCacheKey(): string;
    copy(source: any): this;
    /** Called by three.js render loop */
    onBeforeRender(_this: any, scene: any, camera: any, geometry: any, object: any, group: any): void;
}
export default SpeckleNormalMaterial;
